#!/bin/bash
#!/usr/bin/env bash
# https://gist.github.com/mihow/9c7f559807069a03e302605691f85572

#########################
#### Script env
##
_FORCE_PUSH=""

env
#########################
#### Validate username and password exists
##

if [ -z "${GIT_USERNAME}" ];
  then
    echo "Please set up a username in the environment"
    exit 127
fi

if [ -z "${GIT_PASSWORD}" ];
  then
    echo "Please set up a password in the environment"
    exit 127
fi

if [ -z "${GIT_REPO_URL}" ];
  then
    echo "Please set up a url to push the environment in the environment"
    exit 127
fi

#echo "${GIT_REPO_URL:-not found}"
# Remove .git
rm -rfv ./.git

## TMP
# Create file to keep updating repo
date > README.md

# Tar files in folder (Unless specified otherwise in the config)
#cp -rv /BACKUP_DIR /__BACKUP_DIR || exit 127
#cd /__BACKUP_DIR || exit 127
# Git init
git init

# Git add
git add .


#???
git config user.email "${GIT_COMMIT_EMAIL:-.}"

# Git commit
echo "email $GIT_COMMIT_EMAIL"
echo "author $GIT_COMMIT_AUTHOR"
git commit --author="${GIT_COMMIT_AUTHOR:-Name} ${GIT_COMMIT_EMAIL:-<>}" -m "${GIT_COMMIT_MESSAGE}"

# Git add remote tag
git remote add origin "${GIT_REPO_URL}"

## Git tag
#if [ -n "${GIT_TAG}" ]
#  then
#
#    git tag -a "${GIT_TAG}" -m "${GIT_TAG_MESSAGE:-$GIT_TAG_NAME}"
#    _FORCE_PUSH='-f'
#fi

# Set up credential helper script to use environment variables
chmod +x "$__CREDENTIAL_HELPER_SCRIPT_PATH"
git config credential.helper "/bin/bash ${__CREDENTIAL_HELPER_SCRIPT_PATH}"

# Git push


if [ -n "${GIT_FORCE_PUSH}" ]
  then
    _FORCE_PUSH='-f'
fi


git push  ${_FORCE_PUSH}  origin "HEAD:${GIT_REMOTE_BRANCH}"
#bash